"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.serverInstance = exports["default"] = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _axios = _interopRequireDefault(require("axios"));

var axiosConfig = {
  withCredentials: true,
  // 跨域请求是否提供凭据信息(cookie、HTTP认证及客户端SSL证明等)
  timeout: 10 * 1000 // 10秒钟超时

};

var instance = _axios["default"].create(axiosConfig); // instance.interceptors.request.use((config, b) => {
//   // Do something before request is sent
//   console.log('[b]:', b);
//   console.log('[axios config]:', config);
//   return config;
// }, error => Promise.reject(error));

/**
 * 为了方便纯浏览器端代码书写，直接导出一个 axios 实例
 */


var _default = instance;
/**
 * 服务器端 axios 方法
 * @param {object} req HTTP 请求
 * @return {function} 返回 Axios 实例的方法
 */

exports["default"] = _default;

var serverInstance = function serverInstance(_ref) {
  var req = _ref.req;

  // 服务器端渲染时会传 req
  if (req) {
    instance.defaults.baseURL = "".concat(req.protocol, "://").concat(req.headers.host);
    instance.defaults.headers = (0, _objectSpread2["default"])({}, req.headers, {
      'X-Real-IP': (req.ip || '').split(',')[0]
    });
  }

  return instance;
};

exports.serverInstance = serverInstance;