"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _react = _interopRequireDefault(require("react"));

var _reactRouterDom = require("react-router-dom");

var _reactRouterConfig = require("react-router-config");

var _express = _interopRequireDefault(require("express"));

var _server = require("react-dom/server");

var _server2 = require("@loadable/server");

var _reactHelmet = require("react-helmet");

var _serializeJavascript = _interopRequireDefault(require("serialize-javascript"));

var _redboxReact = require("redbox-react");

var _cookieParser = _interopRequireDefault(require("cookie-parser"));

var _NotFound = _interopRequireDefault(require("./components/NotFound"));

var _addProxy = _interopRequireDefault(require("./utils/addProxy"));

var _addStatic = _interopRequireDefault(require("./utils/addStatic"));

var _document = _interopRequireDefault(require("./document"));

var _ssrRoutes = _interopRequireDefault(require("./ssrRoutes"));

var _jsxFileName = "/Users/zhi.zhong/workspace/github/dacejs/dace/src/runtime/createServer.js";
var server = (0, _express["default"])(); // 绑定请求代理

(0, _addProxy["default"])(server); // 挂载虚拟目录

(0, _addStatic["default"])(server);
server.disable('x-powered-by') // 解析 cookie
.use((0, _cookieParser["default"])()).all('*',
/*#__PURE__*/
function () {
  var _ref = (0, _asyncToGenerator2["default"])(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee2(req, res) {
    var query, pathname, ssr, branch, notFound, html, initialProps, promises, context, Markup, stats, extractor, jsx, markup, scriptTags, styleTags, head, state, _html;

    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            // 查找当前 URL 匹配的路由
            query = req.query, pathname = req._parsedUrl.pathname;
            ssr = process.env.DACE_SSR === 'true';
            branch = (0, _reactRouterConfig.matchRoutes)(_ssrRoutes["default"], pathname); // 匹配的最后一个组件是 `NotFound` 的话，表示地址不存在

            notFound = branch[branch.length - 1].route.component.name === 'NotFound';

            if (!notFound) {
              _context2.next = 8;
              break;
            }

            // 只有网页类请求才走自定义404页面
            if (/html/.test(req.get('accept'))) {
              html = (0, _document["default"])({
                markup: (0, _server.renderToString)(_react["default"].createElement(_NotFound["default"], {
                  location: {
                    pathname: pathname
                  },
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 41
                  }
                }))
              });
              res.status(200).end(html);
            } else {
              // 非网页类请求直接返回404
              res.status(404).end();
            }

            _context2.next = 26;
            break;

          case 8:
            initialProps = {};

            if (!ssr) {
              _context2.next = 16;
              break;
            }

            promises = branch // <- react-router 不匹配 querystring
            .map(
            /*#__PURE__*/
            function () {
              var _ref3 = (0, _asyncToGenerator2["default"])(
              /*#__PURE__*/
              _regenerator["default"].mark(function _callee(_ref2) {
                var route, match, component, AsyncComponent, ctx, props;
                return _regenerator["default"].wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        route = _ref2.route, match = _ref2.match;
                        component = route.component;

                        if (!(component && component.load && typeof component.load === 'function')) {
                          _context.next = 12;
                          break;
                        }

                        _context.next = 5;
                        return component.load();

                      case 5:
                        AsyncComponent = _context.sent["default"];

                        if (!AsyncComponent.getInitialProps) {
                          _context.next = 12;
                          break;
                        }

                        ctx = {
                          match: match,
                          query: query,
                          req: req,
                          res: res
                        };
                        _context.next = 10;
                        return AsyncComponent.getInitialProps(ctx);

                      case 10:
                        props = _context.sent;
                        return _context.abrupt("return", props);

                      case 12:
                        return _context.abrupt("return", null);

                      case 13:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x3) {
                return _ref3.apply(this, arguments);
              };
            }()).filter(Boolean);

            if (!(promises.length > 0)) {
              _context2.next = 16;
              break;
            }

            _context2.next = 14;
            return Promise.all(promises);

          case 14:
            _context2.t0 = function (item) {
              initialProps = (0, _objectSpread2["default"])({}, initialProps, item);
            };

            _context2.sent.forEach(_context2.t0);

          case 16:
            context = {};
            Markup = ssr ? _react["default"].createElement(_reactRouterDom.StaticRouter, {
              context: context,
              location: req.url,
              __source: {
                fileName: _jsxFileName,
                lineNumber: 79
              }
            }, (0, _reactRouterConfig.renderRoutes)(_ssrRoutes["default"], {
              initialProps: initialProps
            })) : null; // This is the stats file generated by webpack loadable plugin

            stats = require(process.env.DACE_PATH_LOADABLE_STATS_JSON); // We create an extractor from the statsFile

            extractor = new _server2.ChunkExtractor({
              stats: stats
            }); // Wrap your application using "collectChunks"

            jsx = extractor.collectChunks(Markup);

            try {
              markup = (0, _server.renderToString)(jsx);
              scriptTags = extractor.getScriptTags();
              styleTags = extractor.getStyleTags();
            } catch (error) {
              res.status(500);
              markup = (0, _server.renderToString)(_react["default"].createElement(_redboxReact.RedBoxError, {
                error: error,
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 100
                }
              }));
            } // renderStatic 需要在 root 元素 renderToString 后执行


            head = _reactHelmet.Helmet.renderStatic();
            state = (0, _serializeJavascript["default"])(initialProps);
            _html = (0, _document["default"])({
              head: head,
              markup: markup,
              state: state,
              styleTags: styleTags,
              scriptTags: scriptTags
            });
            res.status(200).end(_html);

          case 26:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}());
var _default = server;
exports["default"] = _default;
module.exports = exports.default;