"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

/**
 * 自定义服务器端渲染模版
 * 可以通过该模版改写首屏的 DOM 结构
 * @param {object} options 传入参数
 * @param {object} options.head helmet 实例，里面包含 title, meta, link, style, script, noscript 等
 * @param {string} options.markup 服务器端渲染生成的 DOM 字符串
 * @param {string} options.state 服务器端渲染生成的 state 经 JSON.stringify() 后的字符串
 * @param {string} options.styleTags @loadable/component 输出的 state 字符串
 * @param {string} options.scriptTags @loadable/component 输出的 state 字符串
 * @return {string} 首屏 HTML
 */
var _default = function _default(_ref) {
  var _ref$head = _ref.head,
      head = _ref$head === void 0 ? {} : _ref$head,
      _ref$markup = _ref.markup,
      markup = _ref$markup === void 0 ? '' : _ref$markup,
      _ref$state = _ref.state,
      state = _ref$state === void 0 ? '{}' : _ref$state,
      _ref$styleTags = _ref.styleTags,
      styleTags = _ref$styleTags === void 0 ? '' : _ref$styleTags,
      _ref$scriptTags = _ref.scriptTags,
      scriptTags = _ref$scriptTags === void 0 ? '' : _ref$scriptTags;

  var print = function print(key) {
    if (head[key] && typeof head[key].toString === 'function') {
      return head[key].toString();
    }

    return '';
  };

  var metaString = ['title', 'meta', 'link', 'style', 'script', 'noscript'].map(function (key) {
    return print(key);
  }).join('');
  return "<!doctype html>\n  <html ".concat(print('htmlAttributes'), ">\n  <head>\n    <meta charset=\"utf-8\" />").concat(metaString).concat(styleTags, "\n  </head>\n  <body ").concat(print('bodyAttributes.toString'), ">\n    <div id=\"root\">").concat(markup, "</div>\n    <script>window.INITIAL_STATE=").concat(state, ";</script>").concat(scriptTags, "\n  </body>\n  </html>");
};

exports["default"] = _default;
module.exports = exports.default;