"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _http = _interopRequireDefault(require("http"));

var _chalk = _interopRequireDefault(require("chalk"));

var _createServer = _interopRequireDefault(require("./createServer"));

var server = _http["default"].createServer(_createServer["default"]);

var currentApp = _createServer["default"];
server.listen(process.env.DACE_PORT, function (error) {
  if (error) {
    console.log(error);
  }

  var url = _chalk["default"].underline("http://".concat(process.env.DACE_HOST, ":").concat(process.env.DACE_PORT));

  console.log("\n\uD83D\uDC1F Your application is running at ".concat(url));
});

if (module.hot) {
  console.log('✅  Server-side HMR Enabled!');
  module.hot.accept('./server', function () {
    console.log('🔁  HMR Reloading `./server`...');
    server.removeListener('request', currentApp);

    var newApp = require('./server'); // eslint-disable-line


    server.on('request', newApp);
    currentApp = newApp;
  });
}